Index: branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 3864)
+++ branches/2013/dev_r3411_CNRS4_IOCRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 3895)
@@ -571,334 +469,826 @@
       !! 
       !!  Arguments
-      REAL(wp), DIMENSION(jpi,jpj),     INTENT(in)     :: p_e1_e2    ! Parent grid U,V scale factors (e1 or e2)
-      CHARACTER(len=1),                 INTENT(in)     :: cd_type    ! grid type U,V 
-      REAL(wp),                         INTENT(in)     :: psgn       ! sign change option across north fold
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in)     :: p_pmask    ! Parent grid U,V mask
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in)     :: p_fse3     ! Parent grid vertical level thickness (fse3u, fse3v)
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in)     :: p_pfield   ! U or V on parent grid
+      REAL(wp), DIMENSION(jpi,jpj,jpk),         INTENT(in)           :: p_fld   ! T, U, V or W on parent grid
+      CHARACTER(len=3),                         INTENT(in)           :: cd_op    ! Operation SUM, MAX or MIN
+      CHARACTER(len=1),                         INTENT(in)           :: cd_type    ! grid type U,V 
+      REAL(wp), DIMENSION(jpi,jpj,jpk),         INTENT(in)           :: p_mask    ! Parent grid T,U,V mask
+      REAL(wp), DIMENSION(jpi,jpj),             INTENT(in), OPTIONAL :: p_e12    ! Parent grid T,U,V scale factors (e1 or e2)
+      REAL(wp), DIMENSION(jpi,jpj,jpk),         INTENT(in), OPTIONAL :: p_e3     ! Parent grid vertical level thickness (fse3u, fse3v)
       REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(in), OPTIONAL :: p_surf_crs ! Coarse grid area-weighting denominator    
-
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out)  :: p_cfield3d ! Coarse grid box 3D quantity 
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(in), OPTIONAL :: p_mask_crs    ! Coarse grid T,U,V mask
+
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out)          :: p_fld_crs ! Coarse grid box 3D quantity 
 
       !! Local variables
-      INTEGER  :: ji, jj, jk , jii, jjj                  ! dummy loop indices
-      INTEGER  :: ijie, ijis, ijje, ijjs
-      REAL(wp), DIMENSION(:,:,:), POINTER :: zsurfcrs   
+      INTEGER  :: ji, jj, jk                 ! dummy loop indices
+      INTEGER  :: ijie, ijje, ii, ij
+      REAL(wp) :: zflcrs, zsfcrs   
+      REAL(wp) :: zeps = 1.e20    
+      REAL(wp), DIMENSION(:,:,:), POINTER :: zsurf   
 
       !!----------------------------------------------------------------  
-
-      CALL wrk_alloc( jpi_crs, jpj_crs, jpk, zsurfcrs )
-      zsurfcrs(:,:,:) = 1.0
-      IF ( PRESENT(p_surf_crs) ) THEN
-         WHERE ( p_surf_crs /= 0 ) zsurfcrs(:,:,:) = 1.0/p_surf_crs(:,:,:)
-      ENDIF
-
-      DO jk = 1, jpk    
-
-        DO ji = 2, nlei_crs
-            ijie = mie_crs(ji)
-            ijis = mis_crs(ji)
-
-            DO jj = njstart, njend
-               ijje = mje_crs(jj) 
-               ijjs = mjs_crs(jj)                   
-
-               IF ( cd_type == 'V' ) THEN
-
-                  DO jii = ijis, ijie
-                     p_cfield3d(ji,jj,jk) = p_cfield3d(ji,jj,jk) &
-                       & + ( p_pfield(jii,ijje,jk) * p_e1_e2(jii,ijje) * p_fse3(jii,ijje,jk) * p_pmask(jii,ijje,jk) ) 
+   
+
+      SELECT CASE ( cd_op )
+      
+         CASE ( 'VOL' )
+      
+            CALL wrk_alloc( jpi, jpj, jpk, zsurf )
+            DO jk = 1, jpk
+              zsurf(:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk)
+            ENDDO
+         
+            SELECT CASE ( cd_type )
+            
+               CASE( 'T' )
+         
+                  DO jk = 1, jpk
+                    
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)                  
+ 
+                           zflcrs =  p_fld(ji  ,jj  ,jk) * zsurf(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk) &
+                             &     + p_fld(ji+1,jj  ,jk) * zsurf(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk) &
+                             &     + p_fld(ji+2,jj  ,jk) * zsurf(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk) &
+                             &     + p_fld(ji  ,jj+1,jk) * zsurf(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk) &
+                             &     + p_fld(ji+1,jj+1,jk) * zsurf(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk) &
+                             &     + p_fld(ji+2,jj+1,jk) * zsurf(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk) &
+                             &     + p_fld(ji  ,jj+2,jk) * zsurf(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk) &
+                             &     + p_fld(ji+1,jj+2,jk) * zsurf(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk) &
+                             &     + p_fld(ji+2,jj+2,jk) * zsurf(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk) 
+ 
+                           zsfcrs =  zsurf(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk) &
+                             &     + zsurf(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk) &
+                             &     + zsurf(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk) &
+                             &     + zsurf(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk) &
+                             &     + zsurf(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk) &
+                             &     + zsurf(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk) &
+                             &     + zsurf(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk) &
+                             &     + zsurf(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk) &
+                             &     + zsurf(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk) 
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs
+                           IF( zsfcrs /= 0.0 )  p_fld_crs(ii,ij,jk) = zflcrs / zsfcrs
+
+                        ENDDO      
+                     ENDDO
+                  ENDDO   
+            
+               CASE( 'W' )
+         
+                  DO jk = 2, jpk
+                    
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)                  
+ 
+                           zflcrs =  p_fld(ji  ,jj  ,jk) * zsurf(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk-1) &
+                             &     + p_fld(ji+1,jj  ,jk) * zsurf(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk-1) &
+                             &     + p_fld(ji+2,jj  ,jk) * zsurf(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk-1) &
+                             &     + p_fld(ji  ,jj+1,jk) * zsurf(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk-1) &
+                             &     + p_fld(ji+1,jj+1,jk) * zsurf(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk-1) &
+                             &     + p_fld(ji+2,jj+1,jk) * zsurf(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk-1) &
+                             &     + p_fld(ji  ,jj+2,jk) * zsurf(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk-1) &
+                             &     + p_fld(ji+1,jj+2,jk) * zsurf(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk-1) &
+                             &     + p_fld(ji+2,jj+2,jk) * zsurf(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk-1) 
+ 
+                           zsfcrs =  zsurf(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk-1) &
+                             &     + zsurf(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk-1) &
+                             &     + zsurf(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk-1) &
+                             &     + zsurf(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk-1) &
+                             &     + zsurf(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk-1) &
+                             &     + zsurf(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk-1) &
+                             &     + zsurf(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk-1) &
+                             &     + zsurf(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk-1) &
+                             &     + zsurf(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk-1) 
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs
+                           IF( zsfcrs /= 0.0 )  p_fld_crs(ii,ij,jk) = zflcrs / zsfcrs
+
+                        ENDDO      
+                     ENDDO
+                  ENDDO   
+
+                  DO ji = nistr, niend, nn_factx
+                     DO jj = njstr, njend, nn_facty
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ijje = mje_crs(ij)
+                        ijie = mie_crs(ii)                  
+
+                          zflcrs =   p_fld(ji  ,jj  ,1) * zsurf(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1) &
+                             &     + p_fld(ji+1,jj  ,1) * zsurf(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1) &
+                             &     + p_fld(ji+2,jj  ,1) * zsurf(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1) &
+                             &     + p_fld(ji  ,jj+1,1) * zsurf(ji  ,jj+1,1) * p_mask(ji  ,jj+1,1) &
+                             &     + p_fld(ji+1,jj+1,1) * zsurf(ji+1,jj+1,1) * p_mask(ji+1,jj+1,1) &
+                             &     + p_fld(ji+2,jj+1,1) * zsurf(ji+2,jj+1,1) * p_mask(ji+2,jj+1,1) &
+                             &     + p_fld(ji  ,jj+2,1) * zsurf(ji  ,jj+2,1) * p_mask(ji  ,jj+2,1) &
+                             &     + p_fld(ji+1,jj+2,1) * zsurf(ji+1,jj+2,1) * p_mask(ji+1,jj+2,1) &
+                             &     + p_fld(ji+2,jj+2,1) * zsurf(ji+2,jj+2,1) * p_mask(ji+2,jj+2,1) 
+ 
+                           zsfcrs =  zsurf(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1) &
+                             &     + zsurf(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1) &
+                             &     + zsurf(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1) &
+                             &     + zsurf(ji  ,jj+1,1) * p_mask(ji  ,jj+1,1) &
+                             &     + zsurf(ji+1,jj+1,1) * p_mask(ji+1,jj+1,1) &
+                             &     + zsurf(ji+2,jj+1,1) * p_mask(ji+2,jj+1,1) &
+                             &     + zsurf(ji  ,jj+2,1) * p_mask(ji  ,jj+2,1) &
+                             &     + zsurf(ji+1,jj+2,1) * p_mask(ji+1,jj+2,1) &
+                             &     + zsurf(ji+2,jj+2,1) * p_mask(ji+2,jj+2,1) 
+                         
+                        p_fld_crs(ii,ij,1) = zflcrs
+                        IF( zsfcrs /= 0.0 )  p_fld_crs(ii,ij,1) = zflcrs / zsfcrs
+
+                     ENDDO      
                   ENDDO
-                  p_cfield3d(ji,jj,jk) = p_cfield3d(ji,jj,jk) * zsurfcrs(ji,jj,jk) 
-
-               ELSEIF ( cd_type == 'U') THEN
-
-                  DO jjj = ijjs, ijje
-                     p_cfield3d(ji,jj,jk) = p_cfield3d(ji,jj,jk) &
-                       & + ( p_pfield(ijie,jjj,jk) * p_e1_e2(ijie,jjj) * p_fse3(ijie,jjj,jk) * p_pmask(ijie,jjj,jk) )
+
+              END SELECT
+
+              CALL wrk_dealloc( jpi, jpj, jpk, zsurf )
+
+         CASE ( 'SUM' )
+         
+            CALL wrk_alloc( jpi, jpj, jpk, zsurf )
+            DO jk = 1, jpk
+              zsurf(:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk)
+            ENDDO
+         
+            SELECT CASE ( cd_type )
+            
+               CASE( 'T' )
+         
+                  DO jk = 1, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)                  
+ 
+                           zflcrs  =  p_fld(ji  ,jj  ,jk) * zsurf(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk) &
+                             &      + p_fld(ji+1,jj  ,jk) * zsurf(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk) &
+                             &      + p_fld(ji+2,jj  ,jk) * zsurf(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk) &
+                             &      + p_fld(ji  ,jj+1,jk) * zsurf(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk) &
+                             &      + p_fld(ji+1,jj+1,jk) * zsurf(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk) &
+                             &      + p_fld(ji+2,jj+1,jk) * zsurf(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk) &
+                             &      + p_fld(ji  ,jj+2,jk) * zsurf(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk) &
+                             &      + p_fld(ji+1,jj+2,jk) * zsurf(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk) &
+                             &      + p_fld(ji+2,jj+2,jk) * zsurf(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk) 
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs
+                           !
+                        ENDDO      
+                     ENDDO
+                  ENDDO   
+            
+               CASE( 'W' )
+         
+                  DO jk = 2, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)
+                           !                  
+                           zflcrs  =  p_fld(ji  ,jj  ,jk) * zsurf(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk-1) &
+                             &      + p_fld(ji+1,jj  ,jk) * zsurf(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk-1) &
+                             &      + p_fld(ji+2,jj  ,jk) * zsurf(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk-1) &
+                             &      + p_fld(ji  ,jj+1,jk) * zsurf(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk-1) &
+                             &      + p_fld(ji+1,jj+1,jk) * zsurf(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk-1) &
+                             &      + p_fld(ji+2,jj+1,jk) * zsurf(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk-1) &
+                             &      + p_fld(ji  ,jj+2,jk) * zsurf(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk-1) &
+                             &      + p_fld(ji+1,jj+2,jk) * zsurf(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk-1) &
+                             &      + p_fld(ji+2,jj+2,jk) * zsurf(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk-1) 
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs
+                           !
+                        ENDDO      
+                     ENDDO
+                  ENDDO   
+
+                  DO ji = nistr, niend, nn_factx
+                     DO jj = njstr, njend, nn_facty
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ijje = mje_crs(ij)
+                        ijie = mie_crs(ii)                  
+                        !
+                        zflcrs  =   p_fld(ji  ,jj  ,1) * zsurf(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1) &
+                           &      + p_fld(ji+1,jj  ,1) * zsurf(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1) &
+                           &      + p_fld(ji+2,jj  ,1) * zsurf(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1) &
+                           &      + p_fld(ji  ,jj+1,1) * zsurf(ji  ,jj+1,1) * p_mask(ji  ,jj+1,1) &
+                           &      + p_fld(ji+1,jj+1,1) * zsurf(ji+1,jj+1,1) * p_mask(ji+1,jj+1,1) &
+                           &      + p_fld(ji+2,jj+1,1) * zsurf(ji+2,jj+1,1) * p_mask(ji+2,jj+1,1) &
+                           &      + p_fld(ji  ,jj+2,1) * zsurf(ji  ,jj+2,1) * p_mask(ji  ,jj+2,1) &
+                           &      + p_fld(ji+1,jj+2,1) * zsurf(ji+1,jj+2,1) * p_mask(ji+1,jj+2,1) &
+                           &      + p_fld(ji+2,jj+2,1) * zsurf(ji+2,jj+2,1) * p_mask(ji+2,jj+2,1) 
+                        !
+                        p_fld_crs(ii,ij,1) = zflcrs
+                        !
+                     ENDDO      
                   ENDDO
-                  p_cfield3d(ji,jj,jk) = p_cfield3d(ji,jj,jk) * zsurfcrs(ji,jj,jk)
-
-               ENDIF
-                 
-            ENDDO
-         ENDDO
-      ENDDO
-
-! Retroactively add back the boundary halo cells.
-
-      CALL crs_lbc_lnk( p_cfield3d(:,:,:),cd_type,psgn )
-      
-      CALL wrk_dealloc( jpi_crs, jpj_crs, jpk, zsurfcrs )
-
-   END SUBROUTINE crsfun_UV
-
-   SUBROUTINE crsfun_TW( p_e1e2t, cd_type, cd_op, p_cmask, p_ptmask, psgn, p_pfield2d, p_pfield3d_1, p_pfield3d_2, &
-      &                  p_cfield2d, p_cfield3d)
+           
+               CASE( 'V' )
+         
+                  DO jk = 1, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)
+                           !                  
+                           zflcrs  =  p_fld(ji  ,ijje,jk) * zsurf(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk) &
+                             &      + p_fld(ji+1,ijje,jk) * zsurf(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk) &
+                             &      + p_fld(ji+2,ijje,jk) * zsurf(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) 
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs
+                           !
+                         ENDDO      
+                     ENDDO
+                  ENDDO   
+
+            
+               CASE( 'U' )
+         
+                  DO jk = 1, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)
+                           !                  
+                           zflcrs =  p_fld(ijie,jj  ,jk) * zsurf(ijie,jj  ,jk) * p_mask(ijie,jj  ,jk) &
+                             &     + p_fld(ijie,jj+1,jk) * zsurf(ijie,jj+1,jk) * p_mask(ijie,jj+1,jk) &
+                             &     + p_fld(ijie,jj+2,jk) * zsurf(ijie,jj+2,jk) * p_mask(ijie,jj+2,jk)
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs
+                           !
+                        ENDDO      
+                     ENDDO
+                  ENDDO   
+
+              END SELECT
+
+              IF( PRESENT( p_surf_crs ) ) THEN
+                 WHERE ( p_surf_crs /= 0.0 ) p_fld_crs(:,:,:) = p_fld_crs(:,:,:) / p_surf_crs(:,:,:)
+              ENDIF
+
+              CALL wrk_dealloc( jpi, jpj, jpk, zsurf )
+
+         CASE ( 'MAX' )
+         
+            SELECT CASE ( cd_type )
+            
+               CASE( 'T' )
+         
+                  DO jk = 1, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)                  
+ 
+                           zflcrs =  MAX( p_fld(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk),  &
+                             &            p_fld(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk),  &
+                             &            p_fld(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk),  &
+                             &            p_fld(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk),  &
+                             &            p_fld(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk),  &
+                             &            p_fld(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk),  &
+                             &            p_fld(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk),  &
+                             &            p_fld(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk),  &
+                             &            p_fld(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk)   )
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs
+                           !
+                        ENDDO      
+                     ENDDO
+                  ENDDO   
+            
+               CASE( 'W' )
+         
+                  DO jk = 2, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)
+                           !                  
+                           zflcrs =  MAX( p_fld(ji  ,jj  ,jk) * p_mask(ji  ,jj  ,jk-1),  &
+                             &            p_fld(ji+1,jj  ,jk) * p_mask(ji+1,jj  ,jk-1),  &
+                             &            p_fld(ji+2,jj  ,jk) * p_mask(ji+2,jj  ,jk-1),  &
+                             &            p_fld(ji  ,jj+1,jk) * p_mask(ji  ,jj+1,jk-1),  &
+                             &            p_fld(ji+1,jj+1,jk) * p_mask(ji+1,jj+1,jk-1),  &
+                             &            p_fld(ji+2,jj+1,jk) * p_mask(ji+2,jj+1,jk-1),  &
+                             &            p_fld(ji  ,jj+2,jk) * p_mask(ji  ,jj+2,jk-1),  &
+                             &            p_fld(ji+1,jj+2,jk) * p_mask(ji+1,jj+2,jk-1),  &
+                             &            p_fld(ji+2,jj+2,jk) * p_mask(ji+2,jj+2,jk-1) )
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs
+                           !
+                        ENDDO      
+                     ENDDO
+                  ENDDO   
+
+                  DO ji = nistr, niend, nn_factx
+                     DO jj = njstr, njend, nn_facty
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ijje = mje_crs(ij)
+                        ijie = mie_crs(ii)                  
+                        !
+                        zflcrs = MAX( p_fld(ji  ,jj  ,1) * p_mask(ji  ,jj  ,1),  &
+                           &          p_fld(ji+1,jj  ,1) * p_mask(ji+1,jj  ,1),  &
+                           &          p_fld(ji+2,jj  ,1) * p_mask(ji+2,jj  ,1),  &
+                           &          p_fld(ji  ,jj+1,1) * p_mask(ji  ,jj+1,1),  &
+                           &          p_fld(ji+1,jj+1,1) * p_mask(ji+1,jj+1,1),  &
+                           &          p_fld(ji+2,jj+1,1) * p_mask(ji+2,jj+1,1),  &
+                           &          p_fld(ji  ,jj+2,1) * p_mask(ji  ,jj+2,1),  &
+                           &          p_fld(ji+1,jj+2,1) * p_mask(ji+1,jj+2,1),  &
+                           &          p_fld(ji+2,jj+2,1) * p_mask(ji+2,jj+2,1)  ) 
+                         !
+                         p_fld_crs(ii,ij,1) = zflcrs
+                         !
+                     ENDDO      
+                  ENDDO
+           
+               CASE( 'V' )
+         
+                  DO jk = 1, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)
+                           !                  
+                           zflcrs = MAX( p_fld(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk),  &
+                             &           p_fld(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk),  &
+                             &           p_fld(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) )
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs
+                           !
+                        ENDDO      
+                     ENDDO
+                  ENDDO   
+
+            
+               CASE( 'U' )
+         
+                  DO jk = 1, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)
+                           !                  
+                           Zflcrs = MAX( p_fld(ijie,jj  ,jk) * p_mask(ijie,jj  ,jk),  &
+                             &           p_fld(ijie,jj+1,jk) * p_mask(ijie,jj+1,jk),  &
+                             &           p_fld(ijie,jj+2,jk) * p_mask(ijie,jj+2,jk) )
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs
+                           !
+                        ENDDO      
+                     ENDDO
+                  ENDDO   
+
+              END SELECT
+
+         CASE ( 'MIN' )
+            !   Search the min of masked grid cells
+            SELECT CASE ( cd_type )
+            
+               CASE( 'T' )
+         
+                  DO jk = 1, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)                  
+                           
+                           zflcrs =  MIN( p_fld(ji  ,jj  ,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk) ) * zeps ),  &
+                             &            p_fld(ji+1,jj  ,jk) * ( 1. + ( 1. - p_mask(ji+1,jj  ,jk) ) * zeps ),  &
+                             &            p_fld(ji+2,jj  ,jk) * ( 1. + ( 1. - p_mask(ji+2,jj  ,jk) ) * zeps ),  &
+                             &            p_fld(ji  ,jj+1,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk) ) * zeps ),  &
+                             &            p_fld(ji+1,jj+1,jk) * ( 1. + ( 1. - p_mask(ji+1,jj+1,jk) ) * zeps ),  &
+                             &            p_fld(ji+2,jj+1,jk) * ( 1. + ( 1. - p_mask(ji+2,jj+2,jk) ) * zeps ),  &
+                             &            p_fld(ji  ,jj+2,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk) ) * zeps ),  &
+                             &            p_fld(ji+1,jj+2,jk) * ( 1. + ( 1. - p_mask(ji+1,jj+1,jk) ) * zeps ),  &
+                             &            p_fld(ji+2,jj+2,jk) * ( 1. + ( 1. - p_mask(ji+2,jj+2,jk) ) * zeps )   )
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs * p_mask_crs(ii,ij,jk)
+                           !
+                        ENDDO      
+                     ENDDO
+                  ENDDO   
+           
+               CASE( 'W' )
+         
+                  DO jk = 2, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)                  
+                           
+                           zflcrs =  MIN( p_fld(ji  ,jj  ,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk-1) ) * zeps ),  &
+                             &            p_fld(ji+1,jj  ,jk) * ( 1. + ( 1. - p_mask(ji+1,jj  ,jk-1) ) * zeps ),  &
+                             &            p_fld(ji+2,jj  ,jk) * ( 1. + ( 1. - p_mask(ji+2,jj  ,jk-1) ) * zeps ),  &
+                             &            p_fld(ji  ,jj+1,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk-1) ) * zeps ),  &
+                             &            p_fld(ji+1,jj+1,jk) * ( 1. + ( 1. - p_mask(ji+1,jj+1,jk-1) ) * zeps ),  &
+                             &            p_fld(ji+2,jj+1,jk) * ( 1. + ( 1. - p_mask(ji+2,jj+2,jk-1) ) * zeps ),  &
+                             &            p_fld(ji  ,jj+2,jk) * ( 1. + ( 1. - p_mask(ji  ,jj  ,jk-1) ) * zeps ),  &
+                             &            p_fld(ji+1,jj+2,jk) * ( 1. + ( 1. - p_mask(ji+1,jj+1,jk-1) ) * zeps ),  &
+                             &            p_fld(ji+2,jj+2,jk) * ( 1. + ( 1. - p_mask(ji+2,jj+2,jk-1) ) * zeps )   )
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs * p_mask_crs(ii,ij,jk)
+                           !
+                        ENDDO      
+                     ENDDO
+                  ENDDO  
+ 
+                  DO ji = nistr, niend, nn_factx
+                     DO jj = njstr, njend, nn_facty
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ijje = mje_crs(ij)
+                        ijie = mie_crs(ii)                  
+                        
+                        zflcrs =  MIN( p_fld(ji  ,jj  ,1) * ( 1. + ( 1. - p_mask(ji  ,jj  ,1) ) * zeps ),  &
+                          &            p_fld(ji+1,jj  ,1) * ( 1. + ( 1. - p_mask(ji+1,jj  ,1) ) * zeps ),  &
+                          &            p_fld(ji+2,jj  ,1) * ( 1. + ( 1. - p_mask(ji+2,jj  ,1) ) * zeps ),  &
+                          &            p_fld(ji  ,jj+1,1) * ( 1. + ( 1. - p_mask(ji  ,jj  ,1) ) * zeps ),  &
+                          &            p_fld(ji+1,jj+1,1) * ( 1. + ( 1. - p_mask(ji+1,jj+1,1) ) * zeps ),  &
+                          &            p_fld(ji+2,jj+1,1) * ( 1. + ( 1. - p_mask(ji+2,jj+2,1) ) * zeps ),  &
+                          &            p_fld(ji  ,jj+2,1) * ( 1. + ( 1. - p_mask(ji  ,jj  ,1) ) * zeps ),  &
+                          &            p_fld(ji+1,jj+2,1) * ( 1. + ( 1. - p_mask(ji+1,jj+1,1) ) * zeps ),  &
+                          &            p_fld(ji+2,jj+2,1) * ( 1. + ( 1. - p_mask(ji+2,jj+2,1) ) * zeps )   )
+                        !
+                        p_fld_crs(ii,ij,1) = zflcrs * p_mask_crs(ii,ij,1)
+                        !
+                     ENDDO      
+                  ENDDO
+
+               CASE( 'V' )
+         
+                  DO jk = 1, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)                  
+                           
+                           zflcrs =  MIN( p_fld(ji  ,ijje,jk) * ( 1. + ( 1. - p_mask(ji  ,ijje,jk) ) * zeps ),  &
+                             &            p_fld(ji+1,ijje,jk) * ( 1. + ( 1. - p_mask(ji+1,ijje,jk) ) * zeps ),  &
+                             &            p_fld(ji+2,ijje,jk) * ( 1. + ( 1. - p_mask(ji+2,ijje,jk) ) * zeps )   )
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs * p_mask_crs(ii,ij,jk)
+                           !
+                        ENDDO      
+                     ENDDO
+                  ENDDO  
+
+
+               CASE( 'U' )
+         
+                  DO jk = 1, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)                  
+                           
+                           zflcrs =  MIN( p_fld(ijie,jj  ,jk) * ( 1. + ( 1. - p_mask(ijie,jj  ,jk) ) * zeps ),  &
+                             &            p_fld(ijie,jj+1,jk) * ( 1. + ( 1. - p_mask(ijie,jj+1,jk) ) * zeps ),  &
+                             &            p_fld(ijie,jj+2,jk) * ( 1. + ( 1. - p_mask(ijie,jj+2,jk) ) * zeps )   )
+                           !
+                           p_fld_crs(ii,ij,jk) = zflcrs * p_mask_crs(ii,ij,jk)
+                           !
+                        ENDDO      
+                     ENDDO
+                  ENDDO  
+            END SELECT
+            !
+         END SELECT
+         !
+         CALL crs_lbc_lnk( p_fld_crs, cd_type, 1.0 )
+         !
+    END SUBROUTINE crs_dom_ope_3d
+
+    SUBROUTINE crs_dom_ope_2d( p_fld, cd_op, cd_type, p_mask, p_fld_crs, p_e12, p_e3, p_surf_crs, p_mask_crs )
       !!----------------------------------------------------------------
-      !!               *** SUBROUTINE crsfun_TW ***
-      !! ** Purpose :  Five applications.
-      !!               1) Maximum surface quantity 
-      !!                  - Vertical scale factors (fse3t or fse3w) 
-      !!                    max thickness of the parent grid for coarse grid scale factors.
-      !!                  - or diffusion test
-      !!               2) Area-weighted mean quantity: w, or other 3D or 2D quantity
-      !!               3) Volume-weighted mean quantity: tracer
-      !!               4) Minimum surface quantity (diffusion test)
-      !!               5) Area- or Volume- weighted sum.
-      !! ** Method  :  1) - cd_op = 'MAX'. Determines the max vertical thickness of grid boxes
-      !!                    including partial steps for at the bottom
-      !!                    for the coarsened grid, where within the subset of 
-      !!                    the parent grid cells the maximum thickness is taken.
-      !!                    Valid arguments: p_e1e2t, cd_type, cd_op, p_cmask, p_pfield3d_1
-      !!                    Where, normally p_pfield3d_1 is e3t.
-      !!                  - cd_op = 'MAX'. May also be used for say, determining the maximum value of Kz, 
-      !!                    thus p_pfield3d_1 is set to the 3D field, Kz.
-      !!                    Valid arguments: p_e1e2t, cd_type, cd_op, p_cmask, p_pfield3d_1
-      !!               2) - cd_op = 'ARE'. Calculate the area-weighted average (surface e1t*e2t)  
-      !!                    of vertical velocity, w.
-      !!                    Valid arguments: p_e1e2t, cd_type, cd_op, p_cmask, p_pfield3d_1
-      !!                  - cd_op = 'ARE'. Calculate area-weighted average of a 2D quantity (e.g. emp)
-      !!                    Valid arguments: p_e1e2t, cd_type, cd_op, p_cmask, p_pfield2d
-      !!               3) - cd_op = 'VOL'. Calculate the ocean volume (e1e2t*[fse3t|fse3w]) 
-      !!                    Valid arguments: p_e1e2t, cd_type, cd_op, p_cmask, p_pfield3d_1
-      !!                  - cd_op = 'VOL'. Calculate volume-weighted average (volume e1t*e2t*fse3t) of a quantity.
-      !!                    Valid arguments: p_e1e2t, cd_type, cd_op, p_cmask, p_pfield3d_1, p_pfield3d_2
-      !!               4) - cd_op = 'MIN'. Calculate the minimum value on surface e1t*e2t for 3D variables
-      !!                  Valid arguments: p_e1e2t, cd_type, cd_op, p_cmask, p_pfield3d_1
-      !!               5) - cd_op = 'SUM'. Calculate a dimesionally-weighted sum.  This could be area-weighted
-      !!                  or volume-weighted sum. 
-      !! ** Inputs  : p_e1e2t      = parent grid top face surface area, e1t*e2t 
-      !!              cd_type      = grid type T, W (U, V, F) 
-      !!              cd_op        = MAX, ARE, VOL, MIN, SUM
-      !!              p_cmask      =  coarse grid mask
-      !!              p_ptmask     =  parent grid tmask     
-      !!              psgn         = (Optional) sign for lbc_lnk  
-      !!              p_pfield2d   = (Optional) 2D field on parent grid
-      !!              p_pfield3d_1 = (Optional) parent grid fse3t or fse3w
-      !!              p_pfield3d_2 = (Optional) 3D field on parent grid
-      !! ** Outputs : p_cfield2d   = (Optional) 2D field on coarse grid
-      !!              p_cfield3d   = (Optional) 3D field on coarse grid
+      !!               *** SUBROUTINE crsfun_UV ***
+      !! ** Purpose :  Average, area-weighted, of U or V on the east and north faces 
       !!
-      !! 
-      !! History.  30 May.  Editing.  To decide later: Keep all functionality or separate out the mean function.
-      !!            7 Jun   TODO. Need to fix up the parent grid mask to optional like crsfun_UV...
+      !! ** Method  :  The U and V velocities (3D) are determined as the area-weighted averages
+      !!               on the east and north faces, respectively,
+      !!               of the parent grid subset comprising the coarse grid box. 
+      !!               In the case of the V and F grid, the last jrow minus 1 is spurious.
+      !! ** Inputs  : p_e1_e2     = parent grid e1 or e2 (t,u,v,f)
+      !!              cd_type     = grid type (T,U,V,F) for scale factors; for velocities (U or V)
+      !!              psgn        = sign change over north fold (See lbclnk.F90)
+      !!              p_pmask     = parent grid mask (T,U,V,F) for scale factors; 
+      !!                                       for velocities (U or V)
+      !!              p_fse3      = parent grid vertical level thickness (fse3u or fse3v)
+      !!              p_pfield    = U or V on the parent grid
+      !!              p_surf_crs  = (Optional) Coarse grid weight for averaging
+      !! ** Outputs : p_cfield3d = 3D field on coarse grid
+      !!
+      !! History.  29 May.  completed draft.
+      !!            4 Jun.  Revision for WGT
+      !!            5 Jun.  Streamline for area-weighted average only ; separate scale factor and weights.
       !!----------------------------------------------------------------
       !! 
       !!  Arguments
-      REAL(wp), DIMENSION(jpi,jpj),               INTENT(in) :: p_e1e2t      ! Parent grid T surface (e1*e2)
-      CHARACTER(len=1),                           INTENT(in) :: cd_type      ! grid type T, W ( U, V, F)
-      CHARACTER(len=3),                           INTENT(in) :: cd_op        ! operation max, min, area-average, volume-average
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk),   INTENT(in) :: p_cmask      ! Coarse grid T mask
-      REAL(wp), DIMENSION(jpi,jpj,jpk),           INTENT(in) :: p_ptmask     ! Parent grid T mask
-      REAL(wp),                         OPTIONAL, INTENT(in) :: psgn         ! sign for lbc_lnk
-      REAL(wp), DIMENSION(jpi,jpj),     OPTIONAL, INTENT(in) :: p_pfield2d   ! 2D quantity on parent grid, e.g. ssh
-      REAL(wp), DIMENSION(jpi,jpj,jpk), OPTIONAL, INTENT(in) :: p_pfield3d_1 ! Normally parent grid vertical level thickness
-      REAL(wp), DIMENSION(jpi,jpj,jpk), OPTIONAL, INTENT(in) :: p_pfield3d_2 ! 3D tracer or W on parent grid
-
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs),     OPTIONAL, INTENT(out):: p_cfield2d ! Coarse grid box east or north face quantity
-      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), OPTIONAL, INTENT(out):: p_cfield3d ! Coarse grid box east or north face quantity 
+      REAL(wp), DIMENSION(jpi,jpj),             INTENT(in)           :: p_fld   ! T, U, V or W on parent grid
+      CHARACTER(len=3),                         INTENT(in)           :: cd_op    ! Operation SUM, MAX or MIN
+      CHARACTER(len=1),                         INTENT(in)           :: cd_type    ! grid type U,V 
+      REAL(wp), DIMENSION(jpi,jpj,jpk),         INTENT(in)           :: p_mask    ! Parent grid T,U,V mask
+      REAL(wp), DIMENSION(jpi,jpj),             INTENT(in), OPTIONAL :: p_e12    ! Parent grid T,U,V scale factors (e1 or e2)
+      REAL(wp), DIMENSION(jpi,jpj,jpk),         INTENT(in), OPTIONAL :: p_e3     ! Parent grid vertical level thickness (fse3u, fse3v)
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs)    , INTENT(in), OPTIONAL :: p_surf_crs ! Coarse grid area-weighting denominator    
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(in), OPTIONAL :: p_mask_crs    ! Coarse grid T,U,V mask
+
+      REAL(wp), DIMENSION(jpi_crs,jpj_crs)    , INTENT(out)          :: p_fld_crs ! Coarse grid box 3D quantity 
 
       !! Local variables
-      INTEGER ::  ji, jj, jk                   ! dummy loop indices
-      INTEGER :: ijie,ijis,ijje,ijjs,ijpk,jii,jjj
-      INTEGER, DIMENSION(3) :: idims
-      REAL(wp), POINTER, DIMENSION(:,:)   :: ze1e2, zpfield2d, zcfield2d
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ze3, zpfield3d, zcfield3d, zcmask, zpmask  
-      REAL(wp)                            :: zdAm, zsgn
+      INTEGER  :: ji, jj, jk                 ! dummy loop indices
+      INTEGER  :: ijie, ijje, ii, ij
+      REAL(wp) :: zflcrs, zsfcrs   
+      REAL(wp) :: zeps = 1.e20    
+      REAL(wp), DIMENSION(:,:), POINTER :: zsurf   
+
       !!----------------------------------------------------------------  
-      ! Initialize
-
-      CALL wrk_alloc(jpi    , jpj         , ze1e2, zpfield2d )
-      CALL wrk_alloc(jpi    , jpj    , jpk,  ze3 , zpfield3d, zpmask )
-      CALL wrk_alloc(jpi_crs, jpj_crs,      zcfield2d )
-      CALL wrk_alloc(jpi_crs, jpj_crs, jpk, zcfield3d,  zcmask )
-
-
-      ! Arrays, scalars initialization 
-      zpfield2d(:,:)   = 0.0
-      zpfield3d(:,:,:) = 0.0
-      zcfield2d(:,:)   = 0.0
-      zcfield3d(:,:,:) = 0.0
-      zpmask(:,:,:)    = 1.0
-      idims(:)         = 1
-
-      zcmask(:,:,:)    = p_cmask(:,:,:)     
-      zpmask(:,:,:)    = p_ptmask(:,:,:)
-
-      ijpk             = jpk
-
-
-      ! Control of optional arguments
-      !
-      IF ( PRESENT(psgn) ) THEN
-         zsgn = psgn
-      ELSE
-         zsgn = 1.0 
-      ENDIF
-      !
-      IF ( TRIM(cd_op) == 'MAX' ) THEN
-         ! Find the maximum thickness in each parent grid subset
-         IF ( PRESENT(p_pfield3d_1) )  THEN
-            zpfield3d(:,:,:) = p_pfield3d_1(:,:,:)
-            ze3(:,:,:) = 0.0
-            ze1e2(:,:) = 0.0
-         ELSE 
-            WRITE(numout,*) 'crsfun_TW. MAX only 3D arrays supported' 
-         ENDIF 
-      ELSEIF ( TRIM(cd_op) == 'VOL' ) THEN
-         IF ( PRESENT(p_pfield3d_1) ) THEN
-            ze3(:,:,:)       = p_pfield3d_1(:,:,:)
-            IF ( PRESENT(p_pfield3d_2) ) THEN
-!              ! Prep to calculate a volume-averaged mean
-               zpfield3d(:,:,:) = p_pfield3d_2(:,:,:)
-               ze1e2(:,:)       = p_e1e2t(:,:)     
-            ELSE
-               WRITE(numout,*) 'crsfun_TW. WARNING. Supply both e3t and the field for volume-averaged field'
-            ENDIF
-         ELSE
-            WRITE(numout,*) 'crsfun_TW. VOL only 3D arrays supported'  
-         ENDIF
-      ELSEIF ( TRIM(cd_op) == 'ARE' ) THEN
-         ze1e2(:,:) = p_e1e2t(:,:)
-         ze3(:,:,:) = 1.0
-         IF ( PRESENT(p_pfield3d_2) ) THEN
-            ! Prep to do the area-weighted average of (3D) W
-            zpfield3d(:,:,:) = p_pfield3d_2(:,:,:)
-         ELSEIF ( PRESENT(p_pfield2d) ) THEN
-            ! Prep to do the area-weighted average of some 2D quantity 
-            zpfield2d(:,:) = p_pfield2d(:,:) 
-            ijpk=1
-         ENDIF
-      ELSEIF ( TRIM(cd_op) == 'MIN' ) THEN
-         IF ( PRESENT(p_pfield3d_1) ) THEN
-            ! Prep to do get the minimum diffusion on the top face
-            zpfield3d(:,:,:) = p_pfield3d_1(:,:,:)
-            ze3(:,:,:) = 0.0
-            ze1e2(:,:) = 0.0
-         ELSE
-            WRITE(numout,*) 'crsfun_TW. MIN Only 3D arrays supported' 
-         ENDIF
-      ELSEIF ( TRIM(cd_op) == 'SUM' ) THEN
-         ze1e2(:,:) = p_e1e2t(:,:)
-         zpmask(:,:,:) = p_ptmask(:,:,:)
-         ze3(:,:,:) = 1.0
-        IF ( PRESENT(p_pfield3d_1) ) THEN
-            IF ( PRESENT(p_pfield3d_2) ) THEN
-!              ! Prep to calculate a volume-weighted sum
-               zpfield3d(:,:,:) = p_pfield3d_2(:,:,:)
-               ze3(:,:,:) = p_pfield3d_1(:,:,:)
-            ELSE
-               ! Prep to do the area-weighted sum of (3D) W
-               zpfield3d(:,:,:) = p_pfield3d_1(:,:,:)
-            ENDIF
-         ELSEIF ( PRESENT(p_pfield2d) ) THEN
-            ! Prep to do the area-weighted sum of some 2D quantity 
-            zpfield2d(:,:) = p_pfield2d(:,:) 
-            ijpk=1
-         ENDIF 
-      ELSE
-         WRITE(numout,*) 'crsfun_TW. valid cd_op are MAX, MIN, ARE, VOL, SUM' 
-      ENDIF
-
-      ! Determine output 
-      DO jk = 1, ijpk    
-
-         IF ( ijpk == jpk ) zpfield2d(:,:) = zpfield3d(:,:,jk) 
-         zcfield2d(:,:) = 0.0 
-
-           DO ji = 2, nlei_crs
-               ijie = mie_crs(ji)
-               ijis = mis_crs(ji)
-
-             DO jj = njstart, njend
-                  ijje = mje_crs(jj) 
-                  ijjs = mjs_crs(jj)                   
-
-                  ! First determine weighted sums 
-                  IF ( TRIM(cd_op) == 'SUM' .OR. TRIM(cd_op) == 'ARE' .OR. TRIM(cd_op) == 'VOL' ) THEN
-                     ! Area- or volume- weighted sum
-                     ! Accumulate to sum in parent grid subset 
-                    DO jii = ijis, ijie
-                        DO jjj = ijjs, ijje
-                           zcfield2d(ji,jj) = zcfield2d(ji,jj) &
-                              &              + ( zpfield2d(jii,jjj)      &
-                              &                  *   ze1e2(jii,jjj)      &
-                              &                  *     ze3(jii,jjj,jk)   &
-                              &                  *  zpmask(jii,jjj,jk) ) 
-
-                        ENDDO
+   
+
+      SELECT CASE ( cd_op )
+      
+         CASE ( 'VOL' )
+      
+           CALL wrk_alloc( jpi, jpj, zsurf )
+           zsurf(:,:) =  p_e12(:,:) * p_e3(:,:,1) * p_mask(:,:,1)
+                    
+           DO ji = nistr, niend, nn_factx
+              DO jj = njstr, njend, nn_facty
+                 ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                 ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                 ijje = mje_crs(ij)
+                 ijie = mie_crs(ii)                  
+ 
+                 zflcrs =  p_fld(ji  ,jj  ) * zsurf(ji  ,jj  )  &
+                   &     + p_fld(ji+1,jj  ) * zsurf(ji+1,jj  )  &
+                   &     + p_fld(ji+2,jj  ) * zsurf(ji+2,jj  )  &
+                   &     + p_fld(ji  ,jj+1) * zsurf(ji  ,jj+1)  &
+                   &     + p_fld(ji+1,jj+1) * zsurf(ji+1,jj+1)  &
+                   &     + p_fld(ji+2,jj+1) * zsurf(ji+2,jj+1)  &
+                   &     + p_fld(ji  ,jj+2) * zsurf(ji  ,jj+2)  &
+                   &     + p_fld(ji+1,jj+2) * zsurf(ji+1,jj+2)  &
+                   &     + p_fld(ji+2,jj+2) * zsurf(ji+2,jj+2)  
+
+                 zsfcrs =  zsurf(ji,jj  ) + zsurf(ji+1,jj  ) + zsurf(ji+2,jj  )  &
+                   &     + zsurf(ji,jj+1) + zsurf(ji+1,jj+1) + zsurf(ji+2,jj+1)  &
+                   &     + zsurf(ji,jj+2) + zsurf(ji+1,jj+2) + zsurf(ji+2,jj+2)  
+                 !
+                 p_fld_crs(ii,ij) = zflcrs
+                 IF( zsfcrs /= 0.0 )  p_fld_crs(ii,ij) = zflcrs / zsfcrs
+
+              ENDDO      
+           ENDDO
+            
+           CALL wrk_dealloc( jpi, jpj, zsurf )
+
+         CASE ( 'SUM' )
+         
+            CALL wrk_alloc( jpi, jpj, zsurf )
+            zsurf(:,:) =  p_e12(:,:) * p_e3(:,:,1) * p_mask(:,:,1)
+         
+            SELECT CASE ( cd_type )
+            
+               CASE( 'T', 'W' )
+         
+                  DO ji = nistr, niend, nn_factx
+                     DO jj = njstr, njend, nn_facty
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ijje = mje_crs(ij)
+                        ijie = mie_crs(ii)                  
+
+                        zflcrs  =  p_fld(ji  ,jj  ) * zsurf(ji  ,jj  )  &
+                          &      + p_fld(ji+1,jj  ) * zsurf(ji+1,jj  )  &
+                          &      + p_fld(ji+2,jj  ) * zsurf(ji+2,jj  )  &
+                          &      + p_fld(ji  ,jj+1) * zsurf(ji  ,jj+1)  &
+                          &      + p_fld(ji+1,jj+1) * zsurf(ji+1,jj+1)  &
+                          &      + p_fld(ji+2,jj+1) * zsurf(ji+2,jj+1)  &
+                          &      + p_fld(ji  ,jj+2) * zsurf(ji  ,jj+2)  &
+                          &      + p_fld(ji+1,jj+2) * zsurf(ji+1,jj+2)  &
+                          &      + p_fld(ji+2,jj+2) * zsurf(ji+2,jj+2)  
+                        !
+                        p_fld_crs(ii,ij) = zflcrs
+                        !
+                     ENDDO      
+                  ENDDO
+            
+               CASE( 'V' )
+         
+                  DO jk = 1, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)
+                           !                  
+                           zflcrs  =  p_fld(ji  ,ijje) * zsurf(ji  ,ijje)  &
+                             &      + p_fld(ji+1,ijje) * zsurf(ji+1,ijje)  &
+                             &      + p_fld(ji+2,ijje) * zsurf(ji+2,ijje)  
+                           !
+                           p_fld_crs(ii,ij) = zflcrs
+                           !
+                         ENDDO      
                      ENDDO
-
-                  ENDIF
-
-                  ! Calculate weighted average if desired
-                  IF ( TRIM(cd_op) == 'ARE' .OR. TRIM(cd_op) == 'VOL' ) THEN
-
-                     ! Area- or volume- weighted mean
-                     ! Sum first parent grid subset  
-                     zdAm = 0.0
-                     DO jii = ijis, ijie
-                        DO jjj = ijjs, ijje
-                           zdAm = zdAm + (   ze1e2(jii,jjj)               &
-                              &           *    ze3(jii,jjj,jk)            &
-                              &           * zpmask(jii,jjj,jk) )
-                        ENDDO
+                  ENDDO   
+
+            
+               CASE( 'U' )
+         
+                  DO jk = 1, jpk
+                     DO ji = nistr, niend, nn_factx
+                        DO jj = njstr, njend, nn_facty
+                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                           ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                           ijje = mje_crs(ij)
+                           ijie = mie_crs(ii)
+                           !                  
+                           zflcrs =  p_fld(ijie,jj  ) * zsurf(ijie,jj  )  &
+                             &     + p_fld(ijie,jj+1) * zsurf(ijie,jj+1)  &
+                             &     + p_fld(ijie,jj+2) * zsurf(ijie,jj+2) 
+                           !
+                           p_fld_crs(ii,ij) = zflcrs
+                           !
+                        ENDDO      
                      ENDDO
-                     
-                     IF ( zdAm /= 0 )  zcfield2d(ji,jj) = zcfield2d(ji,jj) / zdAm
-
-                  ENDIF
-
-
-                  IF ( TRIM(cd_op) == 'MAX' ) THEN
-                     ! Find max in parent grid subset 
-                     DO jii = ijis, ijie
-                        DO jjj = ijjs, ijje
-                           zcfield2d(ji,jj) = MAX( zcfield2d(ji,jj), zpfield3d(jii,jjj,jk)*zpmask(jii,jjj,jk) ) 
-                        ENDDO
-                     ENDDO
-                  ENDIF
-
-                  IF ( TRIM(cd_op) == 'MIN' ) THEN
-                     ! Find min in parent grid subset  
-                     DO jii = ijis, ijie
-                        DO jjj = ijjs, ijje
-                           IF ( zpmask(jii,jjj,jk) == 1 ) THEN
-                              zcfield2d(ji,jj) = MIN( zcfield2d(ji,jj), zpfield3d(jii,jjj,jk) ) 
-                           ENDIF
-                        ENDDO
-                     ENDDO
-                  ENDIF
-
-               ENDDO
-            ENDDO
-
-            IF ( ijpk == 1 ) THEN
-               IF ( PRESENT(p_cfield2d) ) p_cfield2d(:,:) = zcfield2d(:,:) * zcmask(:,:,jk)
-            ELSE
-               IF ( PRESENT(p_cfield3d) ) p_cfield3d(:,:,jk) = zcfield2d(:,:) * zcmask(:,:,jk)
-            ENDIF    
-
-      ENDDO
-
-
-! Retroactively add back the boundary halo cells.
-
-         IF ( ijpk == 1 ) THEN
-            IF ( PRESENT(p_cfield2d) ) CALL crs_lbc_lnk( p_cfield2d(:,:),cd_type,zsgn )
-         ELSE
-            IF ( PRESENT(p_cfield3d) ) THEN
-               CALL crs_lbc_lnk( p_cfield3d(:,:,:),cd_type,zsgn )
-            ENDIF
-         ENDIF
-     
-      CALL wrk_dealloc(jpi    , jpj         , ze1e2, zpfield2d )
-      CALL wrk_dealloc(jpi    , jpj    , jpk,  ze3 , zpfield3d, zpmask )
-      CALL wrk_dealloc(jpi_crs, jpj_crs,      zcfield2d )
-      CALL wrk_dealloc(jpi_crs, jpj_crs, jpk, zcfield3d,  zcmask )
+                  ENDDO   
+
+              END SELECT
+
+              IF( PRESENT( p_surf_crs ) ) THEN
+                 WHERE ( p_surf_crs /= 0.0 ) p_fld_crs(:,:) = p_fld_crs(:,:) / p_surf_crs(:,:)
+              ENDIF
+
+              CALL wrk_dealloc( jpi, jpj, zsurf )
+
+         CASE ( 'MAX' )
+         
+            SELECT CASE ( cd_type )
+            
+               CASE( 'T', 'W' )
+         
+                  DO ji = nistr, niend, nn_factx
+                     DO jj = njstr, njend, nn_facty
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ijje = mje_crs(ij)
+                        ijie = mie_crs(ii)                  
+
+                        zflcrs =  MAX( p_fld(ji  ,jj  ) * p_mask(ji  ,jj  ,1),  &
+                          &            p_fld(ji+1,jj  ) * p_mask(ji+1,jj  ,1),  &
+                          &            p_fld(ji+2,jj  ) * p_mask(ji+2,jj  ,1),  &
+                          &            p_fld(ji  ,jj+1) * p_mask(ji  ,jj+1,1),  &
+                          &            p_fld(ji+1,jj+1) * p_mask(ji+1,jj+1,1),  &
+                          &            p_fld(ji+2,jj+1) * p_mask(ji+2,jj+1,1),  &
+                          &            p_fld(ji  ,jj+2) * p_mask(ji  ,jj+2,1),  &
+                          &            p_fld(ji+1,jj+2) * p_mask(ji+1,jj+2,1),  &
+                          &            p_fld(ji+2,jj+2) * p_mask(ji+2,jj+2,1)   )
+                        !
+                        p_fld_crs(ii,ij) = zflcrs
+                        !
+                     ENDDO      
+                  ENDDO
+            
+               CASE( 'V' )
+         
+                  DO ji = nistr, niend, nn_factx
+                     DO jj = njstr, njend, nn_facty
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ijje = mje_crs(ij)
+                        ijie = mie_crs(ii)
+                        !                  
+                        zflcrs = MAX( p_fld(ji  ,ijje) * p_mask(ji  ,ijje,1),  &
+                          &           p_fld(ji+1,ijje) * p_mask(ji+1,ijje,1),  &
+                          &           p_fld(ji+2,ijje) * p_mask(ji+2,ijje,1) )
+                        !
+                        p_fld_crs(ii,ij) = zflcrs
+                        !
+                     ENDDO      
+                  ENDDO
+            
+               CASE( 'U' )
+         
+                  DO ji = nistr, niend, nn_factx
+                     DO jj = njstr, njend, nn_facty
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ijje = mje_crs(ij)
+                        ijie = mie_crs(ii)
+                        !                  
+                        zflcrs = MAX( p_fld(ijie,jj  ) * p_mask(ijie,jj  ,1),  &
+                          &           p_fld(ijie,jj+1) * p_mask(ijie,jj+1,1),  &
+                          &           p_fld(ijie,jj+2) * p_mask(ijie,jj+2,1) )
+                        !
+                        p_fld_crs(ii,ij) = zflcrs
+                        !
+                     ENDDO      
+                  ENDDO
+
+              END SELECT
+
+         CASE ( 'MIN' )
+            !   Search the min of masked grid cells
+            SELECT CASE ( cd_type )
+            
+               CASE( 'T', 'W' )
+         
+                  DO ji = nistr, niend, nn_factx
+                     DO jj = njstr, njend, nn_facty
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ijje = mje_crs(ij)
+                        ijie = mie_crs(ii)                  
+                        
+                        zflcrs =  MIN( p_fld(ji  ,jj  ) * ( 1. + ( 1. - p_mask(ji  ,jj  ,1) ) * zeps ),  &
+                          &            p_fld(ji+1,jj  ) * ( 1. + ( 1. - p_mask(ji+1,jj  ,1) ) * zeps ),  &
+                          &            p_fld(ji+2,jj  ) * ( 1. + ( 1. - p_mask(ji+2,jj  ,1) ) * zeps ),  &
+                          &            p_fld(ji  ,jj+1) * ( 1. + ( 1. - p_mask(ji  ,jj  ,1) ) * zeps ),  &
+                          &            p_fld(ji+1,jj+1) * ( 1. + ( 1. - p_mask(ji+1,jj+1,1) ) * zeps ),  &
+                          &            p_fld(ji+2,jj+1) * ( 1. + ( 1. - p_mask(ji+2,jj+2,1) ) * zeps ),  &
+                          &            p_fld(ji  ,jj+2) * ( 1. + ( 1. - p_mask(ji  ,jj  ,1) ) * zeps ),  &
+                          &            p_fld(ji+1,jj+2) * ( 1. + ( 1. - p_mask(ji+1,jj+1,1) ) * zeps ),  &
+                          &            p_fld(ji+2,jj+2) * ( 1. + ( 1. - p_mask(ji+2,jj+2,1) ) * zeps )   )
+                        !
+                        p_fld_crs(ii,ij) = zflcrs * p_mask_crs(ii,ij,1)
+                        !
+                     ENDDO      
+                  ENDDO
  
-
-   END SUBROUTINE crsfun_TW
+               CASE( 'V' )
+         
+                  DO ji = nistr, niend, nn_factx
+                     DO jj = njstr, njend, nn_facty
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ijje = mje_crs(ij)
+                        ijie = mie_crs(ii)                  
+                        
+                        zflcrs =  MIN( p_fld(ji  ,ijje) * ( 1. + ( 1. - p_mask(ji  ,ijje,1) ) * zeps ),  &
+                          &            p_fld(ji+1,ijje) * ( 1. + ( 1. - p_mask(ji+1,ijje,1) ) * zeps ),  &
+                          &            p_fld(ji+2,ijje) * ( 1. + ( 1. - p_mask(ji+2,ijje,1) ) * zeps )   )
+                        !
+                        p_fld_crs(ii,ij) = zflcrs * p_mask_crs(ii,ij,1)
+                        !
+                     ENDDO      
+                  ENDDO
+
+               CASE( 'U' )
+         
+                  DO ji = nistr, niend, nn_factx
+                     DO jj = njstr, njend, nn_facty
+                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
+                        ij   = ( jj - mjs_crs(2) ) * rfacty_r + 2
+                        ijje = mje_crs(ij)
+                        ijie = mie_crs(ii)                  
+                        
+                        zflcrs =  MIN( p_fld(ijie,jj  ) * ( 1. + ( 1. - p_mask(ijie,jj  ,1) ) * zeps ),  &
+                          &            p_fld(ijie,jj+1) * ( 1. + ( 1. - p_mask(ijie,jj+1,1) ) * zeps ),  &
+                          &            p_fld(ijie,jj+2) * ( 1. + ( 1. - p_mask(ijie,jj+2,1) ) * zeps )   )
+                        !
+                        p_fld_crs(ii,ij) = zflcrs * p_mask_crs(ii,ij,1)
+                        !
+                     ENDDO      
+                  ENDDO
+            END SELECT
+            !
+         END SELECT
+         !
+         CALL crs_lbc_lnk( p_fld_crs, cd_type, 1.0 )
+         !
+   END SUBROUTINE crs_dom_ope_2d
 
 
